#ifndef _PW_PWJOB_H
#define _PW_PWJOB_H

/*
	ProWesS, PROGS Windowing System

	ProWesS job information

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 14 January 1995
*/

#include <mem.h>

/* Information for this specific job */
/* This contains the MEMUser handlers for the builtin types */
/* The PWJob information is stored in a double linked circular list */
/* with header/sentinel object (job=-1) */

typedef struct _PWJob PWJob;

struct _PWJob {
	struct _PWJob *next;			/* next object in list */
	struct _PWJob *prev;			/* previous object in list */
	Job job;						/* job id of owner */
	PWTypeDef *ltyp_list;			/* list of locally defined types */
};

Error PWJobCreate(PWJob **jobinfo);

#endif _PW_PWJOB_H
