        include drv1_C68_include_pws_aid_mac
        section text
; auxiliary routines for ProWesS
; to allow the conversion of PROforma coordinates (in pt) to window coordinates
; (in pixels) and vice versa. Also option to truncate PROforma coordinates to
; round pixels.

    xref    _Xpoint2pixel,_Ypoint2pixel
    xref    _Xpixel2point,_Ypixel2point

; convert PROforma to integer pixel coordinates

_PF2xpix xsub
    move.l  _Xpoint2pixel(pc),d0
    bra.s   PF2pix
_PF2ypix xsub
    move.l  _Ypoint2pixel(pc),d0
PF2pix
    move.l  4(sp),d1
; equivalent with pt2short(fixmul((x),d0))
; d0 is always positive
    regsave d2/d3/d5

        move.l  d1,d5       ; keep sign
        bpl.s   PF2pixP
        neg.l   d1
PF2pixP
        move.l  d0,d2
        move.l  d1,d3
        swap    d3
        swap    d2
        mulu    d2,d1
        mulu    d3,d0
        mulu    d3,d2
        add.l   d1,d0
        add.l   #$1000,d0   ; stop degradation of coordinates because both
                            ; factors are actually truncated and will therefore
                            ; create constant decrease of value when applied
                            ; repeatedly
        swap    d0
        add.w   d2,d0
        ext.l   d0

PF2pixE tst.l   d5
        bpl.s   PF2pixO
        neg.l   d0
PF2pixO subend

; convert integer pixel to PROforma coordinates

_xpix2PF xsub
    move.l  _Xpixel2point(pc),d0
    bra.s   pix2PF
_ypix2PF xsub
    move.l  _Ypixel2point(pc),d0
pix2PF
    move.w  4(sp),d1
; equivalent with ((int)(x)*d0), but somewhat optimized because of short*long,
; and because d0 is always positive
    regsave d2/d5

        move.w  d1,d5       ; keep sign
        bpl.s   pix2PFp
        neg.w   d1
pix2PFp
        move.l  d0,d2
        swap    d2
        mulu    d1,d0
        mulu    d1,d2
        swap    d2
        clr.w   d2

        add.l   d2,d0

pix2PFe
        add.l   #$1000,d0   ; stop degradation of coordinates because both
                            ; factors are actually truncated and will therefore
                            ; create constant decrease of value when applied
                            ; repeatedly
        tst.w   d5
        bpl.s   pix2PFo
        neg.l   d0
pix2PFo subend

; truncate PROforma coordinates to round pixels

_PFxround xsub
    move.l  4(sp),-(sp)
    move.l  _Xpoint2pixel,d0
    bsr     PF2pix
    addq.l  #4,sp
    move.w  d0,4(sp)
    move.l  _Xpixel2point,d0
    bra     pix2PF
_PFyround xsub
    move.l  4(sp),-(sp)
    move.l  _Ypoint2pixel,d0
    bsr     PF2pix
    addq.l  #4,sp
    move.w  d0,4(sp)
    move.l  _Ypixel2point,d0
    bra     pix2PF

*
        end
